]> git.ipfire.org Git - ipfire-2.x.git/blob - make.sh
5d71bab789b990a5f6721009af65fbe7613317ca
[ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007-2018 IPFire Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.19" # Version number
28 CORE="121" # Core Level (Filename)
29 PAKFIRE_CORE="120" # Core Level (PAKFIRE)
30 GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
31 SLOGAN="www.ipfire.org" # Software slogan
32 CONFIG_ROOT=/var/ipfire # Configuration rootdir
33 NICE=10 # Nice level
34 MAX_RETRIES=1 # prefetch/check loop
35 BUILD_IMAGES=1 # Flash and Xen Downloader
36 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37 GIT_TAG=$(git tag | tail -1) # Git Tag
38 GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
39
40 TOOLCHAINVER=20180213
41
42 ###############################################################################
43 #
44 # Beautifying variables & presentation & input output interface
45 #
46 ###############################################################################
47
48 # Remember if the shell is interactive or not
49 if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51 else
52 INTERACTIVE=false
53 fi
54
55 # Sets or adjusts pretty formatting variables
56 resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
65
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
73 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
74 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
75 }
76
77 # Initially setup terminal
78 resize_terminal
79
80 # Call resize_terminal when terminal is being resized
81 trap "resize_terminal" WINCH
82
83 # Define color for messages
84 BOLD="\\033[1;39m"
85 DONE="\\033[1;32m"
86 SKIP="\\033[1;34m"
87 WARN="\\033[1;35m"
88 FAIL="\\033[1;31m"
89 NORMAL="\\033[0;39m"
90
91 # New architecture variables
92 HOST_ARCH="$(uname -m)"
93
94 PWD=$(pwd)
95 BASENAME=$(basename $0)
96
97 # Debian specific settings
98 if [ ! -e /etc/debian_version ]; then
99 FULLPATH=`which $0`
100 else
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
107 fi
108
109 # This is the directory where make.sh is in
110 export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
111
112 LOGFILE=$BASEDIR/log/_build.preparation.log
113 export LOGFILE
114 DIR_CHK=$BASEDIR/cache/check
115 mkdir $BASEDIR/log/ 2>/dev/null
116
117 system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119 }
120
121 system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133 }
134
135 configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
147 CFLAGS_ARCH="-m64 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic"
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
154 CFLAGS_ARCH="-march=i586 -mindirect-branch=thunk -mfunction-return=thunk -mtune=generic -fomit-frame-pointer"
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
161 CFLAGS_ARCH=""
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
211 local cpu_max=$(( ${processors} + 1 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 # limit to -j23 because perl will not build
221 # more
222 if [ ${parallelism} -gt 23 ]; then
223 parallelism=23
224 fi
225
226 MAKETUNING="-j${parallelism}"
227 fi
228 }
229
230 configure_build_guess() {
231 case "${HOST_ARCH}" in
232 x86_64|i686|i586)
233 echo "i586"
234 ;;
235
236 aarch64)
237 echo "aarch64"
238 ;;
239
240 armv7*|armv6*|armv5*)
241 echo "armv5tel"
242 ;;
243
244 *)
245 exiterror "Cannot guess build architecture"
246 ;;
247 esac
248 }
249
250 stdumount() {
251 umount $BASEDIR/build/sys 2>/dev/null;
252 umount $BASEDIR/build/dev/shm 2>/dev/null;
253 umount $BASEDIR/build/dev/pts 2>/dev/null;
254 umount $BASEDIR/build/dev 2>/dev/null;
255 umount $BASEDIR/build/proc 2>/dev/null;
256 umount $BASEDIR/build/install/mnt 2>/dev/null;
257 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
258 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
259 umount $BASEDIR/build/usr/src/config 2>/dev/null;
260 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
261 umount $BASEDIR/build/usr/src/html 2>/dev/null;
262 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
263 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
264 umount $BASEDIR/build/usr/src/log 2>/dev/null;
265 umount $BASEDIR/build/usr/src/src 2>/dev/null;
266 }
267
268 now() {
269 date -u "+%s"
270 }
271
272 format_runtime() {
273 local seconds=${1}
274
275 if [ ${seconds} -ge 3600 ]; then
276 printf "%d:%02d:%02d\n" \
277 "$(( seconds / 3600 ))" \
278 "$(( seconds % 3600 / 60 ))" \
279 "$(( seconds % 3600 % 60 ))"
280 elif [ ${seconds} -ge 60 ]; then
281 printf "%d:%02d\n" \
282 "$(( seconds / 60 ))" \
283 "$(( seconds % 60 ))"
284 else
285 printf "%d\n" "${seconds}"
286 fi
287 }
288
289 print_line() {
290 local line="$@"
291
292 printf "%-${LINE_WIDTH}s" "${line}"
293 }
294
295 _print_line() {
296 local status="${1}"
297 shift
298
299 if ${INTERACTIVE}; then
300 printf "${!status}"
301 fi
302
303 print_line "$@"
304
305 if ${INTERACTIVE}; then
306 printf "${NORMAL}"
307 fi
308 }
309
310 print_headline() {
311 _print_line BOLD "$@"
312 }
313
314 print_error() {
315 _print_line FAIL "$@"
316 }
317
318 print_package() {
319 local name="${1}"
320 shift
321
322 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
323 local options="$@"
324
325 local string="${name}"
326 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
327 string="${string} (${version})"
328 fi
329
330 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
331 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
332 }
333
334 print_runtime() {
335 local runtime=$(format_runtime $@)
336
337 if ${INTERACTIVE}; then
338 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
339 else
340 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
341 fi
342 }
343
344 print_status() {
345 local status="${1}"
346
347 local color="${!status}"
348
349 if ${INTERACTIVE}; then
350 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
351 else
352 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
353 fi
354 }
355
356 print_build_stage() {
357 print_headline "$@"
358
359 # end line
360 printf "\n"
361 }
362
363 print_build_summary() {
364 local runtime=$(format_runtime $@)
365
366 print_line "*** Build finished in ${runtime}"
367 print_status DONE
368 }
369
370 exiterror() {
371 stdumount
372 for i in `seq 0 7`; do
373 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
374 losetup -d /dev/loop${i} 2>/dev/null
375 fi;
376 done
377
378 # Dump logfile
379 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
380 echo # empty line
381
382 local line
383 while read -r line; do
384 echo " ${line}"
385 done <<< "$(tail -n30 ${LOGFILE})"
386 fi
387
388 echo # empty line
389
390 local line
391 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
392 print_error "${line}"
393 print_status FAIL
394 done
395
396 exit 1
397 }
398
399 prepareenv() {
400 # Are we running the right shell?
401 if [ -z "${BASH}" ]; then
402 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
403 fi
404
405 if [ -z "${BASH_VERSION}" ]; then
406 exiterror "Not running BASH shell."
407 fi
408
409 # Trap on emergency exit
410 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
411
412 # Resetting our nice level
413 if ! renice ${NICE} $$ >/dev/null; then
414 exiterror "Failed to set nice level to ${NICE}"
415 fi
416
417 # Checking if running as root user
418 if [ $(id -u) -ne 0 ]; then
419 exiterror "root privileges required for building"
420 fi
421
422 # Checking for necessary temporary space
423 print_line "Checking for necessary space on disk $BASE_DEV"
424 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
425 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
426 if (( 2048000 > $BASE_ASPACE )); then
427 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
428 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
429 print_status FAIL
430 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
431 fi
432 else
433 print_status DONE
434 fi
435
436 # Set umask
437 umask 022
438
439 # Set LFS Directory
440 LFS=$BASEDIR/build
441
442 # Setup environment
443 set +h
444 LC_ALL=POSIX
445 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
446 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
447
448 # Make some extra directories
449 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
450 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
451 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
452 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
453 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
454
455 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
456 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
457
458 # Make all sources and proc available under lfs build
459 mount --bind /dev $BASEDIR/build/dev
460 mount --bind /dev/pts $BASEDIR/build/dev/pts
461 mount --bind /dev/shm $BASEDIR/build/dev/shm
462 mount --bind /proc $BASEDIR/build/proc
463 mount --bind /sys $BASEDIR/build/sys
464 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
465 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
466 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
467 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
468 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
469 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
470 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
471 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
472 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
473
474 # Run LFS static binary creation scripts one by one
475 export CCACHE_DIR=$BASEDIR/ccache
476 export CCACHE_COMPRESS=1
477 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
478
479 # Remove pre-install list of installed files in case user erase some files before rebuild
480 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
481
482 # Prepare string for /etc/system-release.
483 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
484 if [ "$(git status -s | wc -l)" == "0" ]; then
485 GIT_STATUS=""
486 else
487 GIT_STATUS="-dirty"
488 fi
489 case "$GIT_BRANCH" in
490 core*|beta?|rc?)
491 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
492 ;;
493 *)
494 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
495 ;;
496 esac
497 }
498
499 enterchroot() {
500 # Install QEMU helper, if needed
501 qemu_install_helper
502
503 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
504
505 PATH="${PATH}" chroot ${LFS} env -i \
506 HOME="/root" \
507 TERM="${TERM}" \
508 PS1="${PS1}" \
509 PATH="${PATH}" \
510 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
511 PAKFIRE_CORE="${PAKFIRE_CORE}" \
512 NAME="${NAME}" \
513 SNAME="${SNAME}" \
514 VERSION="${VERSION}" \
515 CORE="${CORE}" \
516 SLOGAN="${SLOGAN}" \
517 TOOLS_DIR="${TOOLS_DIR}" \
518 CONFIG_ROOT="${CONFIG_ROOT}" \
519 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
520 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
521 BUILDTARGET="${BUILDTARGET}" \
522 CROSSTARGET="${CROSSTARGET}" \
523 BUILD_ARCH="${BUILD_ARCH}" \
524 BUILD_PLATFORM="${BUILD_PLATFORM}" \
525 CCACHE_DIR=/usr/src/ccache \
526 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
527 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
528 KVER="${KVER}" \
529 XZ_OPT="${XZ_OPT}" \
530 $(fake_environ) \
531 $(qemu_environ) \
532 "$@"
533 }
534
535 entershell() {
536 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
537 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
538 fi
539
540 echo "Entering to a shell inside LFS chroot, go out with exit"
541 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
542
543 if enterchroot bash -i; then
544 stdumount
545 else
546 print_status FAIL
547 exiterror "chroot error"
548 fi
549 }
550
551 lfsmakecommoncheck() {
552 # Script present?
553 if [ ! -f $BASEDIR/lfs/$1 ]; then
554 exiterror "No such file or directory: $BASEDIR/$1"
555 fi
556
557 # Print package name and version
558 print_package $@
559
560 # Check if this package is supported by our architecture.
561 # If no SUP_ARCH is found, we assume the package can be built for all.
562 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
563 # Check if package supports ${BUILD_ARCH} or all architectures.
564 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
565 print_runtime 0
566 print_status SKIP
567 return 1
568 fi
569 fi
570
571 # Script slipped?
572 local i
573 for i in $SKIP_PACKAGE_LIST
574 do
575 if [ "$i" == "$1" ]; then
576 print_status SKIP
577 return 1;
578 fi
579 done
580
581 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
582
583 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
584 MESSAGE="$1\t " download >> $LOGFILE 2>&1
585 if [ $? -ne 0 ]; then
586 exiterror "Download error in $1"
587 fi
588
589 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
590 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
591 if [ $? -ne 0 ]; then
592 exiterror "md5sum error in $1, check file in cache or signature"
593 fi
594
595 return 0 # pass all!
596 }
597
598 lfsmake1() {
599 lfsmakecommoncheck $*
600 [ $? == 1 ] && return 0
601
602 cd $BASEDIR/lfs && env -i \
603 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
604 CCACHE_DIR="${CCACHE_DIR}" \
605 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
606 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
607 CFLAGS="${CFLAGS}" \
608 CXXFLAGS="${CXXFLAGS}" \
609 MAKETUNING="${MAKETUNING}" \
610 make -f $* \
611 TOOLCHAIN=1 \
612 TOOLS_DIR="${TOOLS_DIR}" \
613 CROSSTARGET="${CROSSTARGET}" \
614 BUILDTARGET="${BUILDTARGET}" \
615 BUILD_ARCH="${BUILD_ARCH}" \
616 BUILD_PLATFORM="${BUILD_PLATFORM}" \
617 LFS_BASEDIR="${BASEDIR}" \
618 ROOT="${LFS}" \
619 KVER="${KVER}" \
620 install >> $LOGFILE 2>&1 &
621
622 if ! wait_until_finished $!; then
623 print_status FAIL
624 exiterror "Building $*"
625 fi
626
627 print_status DONE
628 }
629
630 lfsmake2() {
631 lfsmakecommoncheck $*
632 [ $? == 1 ] && return 0
633
634 local PS1='\u:\w$ '
635
636 enterchroot \
637 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
638 MAKETUNING=${MAKETUNING} \
639 make -f $* \
640 LFS_BASEDIR=/usr/src install" \
641 >> ${LOGFILE} 2>&1 &
642
643 if ! wait_until_finished $!; then
644 print_status FAIL
645 exiterror "Building $*"
646 fi
647
648 print_status DONE
649 }
650
651 ipfiredist() {
652 lfsmakecommoncheck $*
653 [ $? == 1 ] && return 0
654
655 local PS1='\u:\w$ '
656
657 enterchroot \
658 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
659 >> ${LOGFILE} 2>&1 &
660
661 if ! wait_until_finished $!; then
662 print_status FAIL
663 exiterror "Packaging $*"
664 fi
665
666 print_status DONE
667 }
668
669 wait_until_finished() {
670 local pid=${1}
671
672 local start_time=$(now)
673
674 # Show progress
675 if ${INTERACTIVE}; then
676 # Wait a little just in case the process
677 # has finished very quickly.
678 sleep 0.1
679
680 local runtime
681 while kill -0 ${pid} 2>/dev/null; do
682 print_runtime $(( $(now) - ${start_time} ))
683
684 # Wait a little
685 sleep 1
686 done
687 fi
688
689 # Returns the exit code of the child process
690 wait ${pid}
691 local ret=$?
692
693 if ! ${INTERACTIVE}; then
694 print_runtime $(( $(now) - ${start_time} ))
695 fi
696
697 return ${ret}
698 }
699
700 fake_environ() {
701 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
702
703 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
704
705 # Fake kernel version, because some of the packages do not compile
706 # with kernel 3.0 and later.
707 env="${env} UTS_RELEASE=${KVER}"
708
709 # Fake machine version.
710 env="${env} UTS_MACHINE=${BUILD_ARCH}"
711
712 echo "${env}"
713 }
714
715 qemu_environ() {
716 local env
717
718 # Don't add anything if qemu is not used.
719 if ! qemu_is_required; then
720 return
721 fi
722
723 # Set default qemu options
724 case "${BUILD_ARCH}" in
725 arm*)
726 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
727
728 env="${env} QEMU_CPU=${QEMU_CPU}"
729 ;;
730 esac
731
732 # Enable QEMU strace
733 #env="${env} QEMU_STRACE=1"
734
735 echo "${env}"
736 }
737
738 qemu_is_required() {
739 local build_arch="${1}"
740
741 if [ -z "${build_arch}" ]; then
742 build_arch="${BUILD_ARCH}"
743 fi
744
745 case "${HOST_ARCH},${build_arch}" in
746 x86_64,arm*|i?86,arm*|i?86,x86_64)
747 return 0
748 ;;
749 *)
750 return 1
751 ;;
752 esac
753 }
754
755 qemu_install_helper() {
756 # Do nothing, if qemu is not required
757 if ! qemu_is_required; then
758 return 0
759 fi
760
761 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
762 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
763 fi
764
765 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
766 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
767 fi
768
769
770 if [ -z "${QEMU_TARGET_HELPER}" ]; then
771 exiterror "QEMU_TARGET_HELPER not set"
772 fi
773
774 # Check if the helper is already installed.
775 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
776 return 0
777 fi
778
779 # Try to find a suitable binary that we can install
780 # to the build environment.
781 local file
782 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
783 # file must exist and be executable.
784 [ -x "${file}" ] || continue
785
786 # Must be static.
787 file_is_static "${file}" || continue
788
789 local dirname="${LFS}$(dirname "${file}")"
790 mkdir -p "${dirname}"
791
792 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
793 return 0
794 done
795
796 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
797 }
798
799 qemu_find_build_helper_name() {
800 local build_arch="${1}"
801
802 local magic
803 case "${build_arch}" in
804 arm*)
805 magic="7f454c4601010100000000000000000002002800"
806 ;;
807 x86_64)
808 magic="7f454c4602010100000000000000000002003e00"
809 ;;
810 esac
811
812 [ -z "${magic}" ] && return 1
813
814 local file
815 for file in /proc/sys/fs/binfmt_misc/*; do
816 # skip write only register entry
817 [ $(basename "${file}") = "register" ] && continue
818 # Search for the file with the correct magic value.
819 grep -qE "^magic ${magic}$" "${file}" || continue
820
821 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
822
823 [ -n "${interpreter}" ] || continue
824 [ "${interpreter:0:1}" = "/" ] || continue
825 [ -x "${interpreter}" ] || continue
826
827 echo "${interpreter}"
828 return 0
829 done
830
831 return 1
832 }
833
834 file_is_static() {
835 local file="${1}"
836
837 file ${file} 2>/dev/null | grep -q "statically linked"
838 }
839
840 update_language_list() {
841 local path="${1}"
842
843 local lang
844 for lang in ${path}/*.po; do
845 lang="$(basename "${lang}")"
846 echo "${lang%*.po}"
847 done | sort -u > "${path}/LINGUAS"
848 }
849
850 # Load configuration file
851 if [ -f .config ]; then
852 . .config
853 fi
854
855 # TARGET_ARCH is BUILD_ARCH now
856 if [ -n "${TARGET_ARCH}" ]; then
857 BUILD_ARCH="${TARGET_ARCH}"
858 unset TARGET_ARCH
859 fi
860
861 # Get the amount of memory in this build system
862 HOST_MEM=$(system_memory)
863
864 # Checking host memory, tuning XZ_OPT
865 if [ $HOST_MEM -lt 1024 ]; then
866 print_build_stage "Host-Memory: $HOST_MEM MiB"
867 print_build_stage "Not enough host memory (less than 1024 MiB, please consider upgrading)"
868
869 exit 1
870 else
871 XZ_MEM="$(( HOST_MEM * 7 / 10 ))MiB"
872 XZ_OPT="-T4 -8 --memory=$XZ_MEM"
873 fi
874
875 if [ -n "${BUILD_ARCH}" ]; then
876 configure_build "${BUILD_ARCH}"
877 else
878 configure_build "default"
879 fi
880
881 buildtoolchain() {
882 local error=false
883 case "${BUILD_ARCH}:${HOST_ARCH}" in
884 # x86_64
885 x86_64:x86_64)
886 # This is working.
887 ;;
888
889 # x86
890 i586:i586|i586:i686|i586:x86_64)
891 # These are working.
892 ;;
893 i586:*)
894 error=true
895 ;;
896
897 # ARM
898 arvm7hl:armv7hl|armv7hl:armv7l)
899 # These are working.
900 ;;
901
902 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
903 # These are working.
904 ;;
905 armv5tel:*)
906 error=true
907 ;;
908 esac
909
910 ${error} && \
911 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
912
913 local gcc=$(type -p gcc)
914 if [ -z "${gcc}" ]; then
915 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
916 fi
917
918 # Check ${TOOLS_DIR} symlink
919 if [ -h "${TOOLS_DIR}" ]; then
920 rm -f "${TOOLS_DIR}"
921 fi
922
923 if [ ! -e "${TOOLS_DIR}" ]; then
924 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
925 fi
926
927 if [ ! -h "${TOOLS_DIR}" ]; then
928 exiterror "Could not create ${TOOLS_DIR} symbolic link"
929 fi
930
931 LOGFILE="$BASEDIR/log/_build.toolchain.log"
932 export LOGFILE
933
934 lfsmake1 stage1
935 lfsmake1 ccache PASS=1
936 lfsmake1 binutils PASS=1
937 lfsmake1 gcc PASS=1
938 lfsmake1 linux KCFG="-headers"
939 lfsmake1 glibc
940 lfsmake1 gcc PASS=L
941 lfsmake1 binutils PASS=2
942 lfsmake1 gcc PASS=2
943 lfsmake1 zlib
944 lfsmake1 ccache PASS=2
945 lfsmake1 tcl
946 lfsmake1 expect
947 lfsmake1 dejagnu
948 lfsmake1 pkg-config
949 lfsmake1 ncurses
950 lfsmake1 bash
951 lfsmake1 bzip2
952 lfsmake1 automake
953 lfsmake1 coreutils
954 lfsmake1 diffutils
955 lfsmake1 findutils
956 lfsmake1 gawk
957 lfsmake1 gettext
958 lfsmake1 grep
959 lfsmake1 gzip
960 lfsmake1 m4
961 lfsmake1 make
962 lfsmake1 patch
963 lfsmake1 perl
964 lfsmake1 sed
965 lfsmake1 tar
966 lfsmake1 texinfo
967 lfsmake1 xz
968 lfsmake1 bison
969 lfsmake1 flex
970 lfsmake1 fake-environ
971 lfsmake1 strip
972 lfsmake1 cleanup-toolchain
973 }
974
975 buildbase() {
976 LOGFILE="$BASEDIR/log/_build.base.log"
977 export LOGFILE
978 lfsmake2 stage2
979 lfsmake2 linux KCFG="-headers"
980 lfsmake2 man-pages
981 lfsmake2 glibc
982 lfsmake2 tzdata
983 lfsmake2 cleanup-toolchain
984 lfsmake2 zlib
985 lfsmake2 binutils
986 lfsmake2 gmp
987 lfsmake2 gmp-compat
988 lfsmake2 mpfr
989 lfsmake2 libmpc
990 lfsmake2 file
991 lfsmake2 gcc
992 lfsmake2 sed
993 lfsmake2 autoconf
994 lfsmake2 automake
995 lfsmake2 berkeley
996 lfsmake2 coreutils
997 lfsmake2 iana-etc
998 lfsmake2 m4
999 lfsmake2 bison
1000 lfsmake2 ncurses
1001 lfsmake2 procps
1002 lfsmake2 libtool
1003 lfsmake2 perl
1004 lfsmake2 readline
1005 lfsmake2 readline-compat
1006 lfsmake2 bzip2
1007 lfsmake2 pcre
1008 lfsmake2 pcre-compat
1009 lfsmake2 bash
1010 lfsmake2 diffutils
1011 lfsmake2 e2fsprogs
1012 lfsmake2 ed
1013 lfsmake2 findutils
1014 lfsmake2 flex
1015 lfsmake2 gawk
1016 lfsmake2 gettext
1017 lfsmake2 grep
1018 lfsmake2 groff
1019 lfsmake2 gperf
1020 lfsmake2 gzip
1021 lfsmake2 hostname
1022 lfsmake2 iproute2
1023 lfsmake2 jwhois
1024 lfsmake2 kbd
1025 lfsmake2 less
1026 lfsmake2 pkg-config
1027 lfsmake2 make
1028 lfsmake2 man
1029 lfsmake2 kmod
1030 lfsmake2 net-tools
1031 lfsmake2 patch
1032 lfsmake2 psmisc
1033 lfsmake2 shadow
1034 lfsmake2 sysklogd
1035 lfsmake2 sysvinit
1036 lfsmake2 tar
1037 lfsmake2 texinfo
1038 lfsmake2 util-linux
1039 lfsmake2 udev
1040 lfsmake2 vim
1041 lfsmake2 xz
1042 lfsmake2 paxctl
1043 }
1044
1045 buildipfire() {
1046 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1047 export LOGFILE
1048 lfsmake2 configroot
1049 lfsmake2 initscripts
1050 lfsmake2 backup
1051 lfsmake2 libusb
1052 lfsmake2 libusb-compat
1053 lfsmake2 libpcap
1054 lfsmake2 ppp
1055 lfsmake2 pptp
1056 lfsmake2 unzip
1057 lfsmake2 which
1058 lfsmake2 linux-firmware
1059 lfsmake2 dvb-firmwares
1060 lfsmake2 xr819-firmware
1061 lfsmake2 zd1211-firmware
1062 lfsmake2 rpi-firmware
1063 lfsmake2 bc
1064 lfsmake2 u-boot MKIMAGE=1
1065 lfsmake2 cpio
1066 lfsmake2 mdadm
1067 lfsmake2 dracut
1068 lfsmake2 lvm2
1069 lfsmake2 multipath-tools
1070 lfsmake2 freetype
1071 lfsmake2 grub
1072 lfsmake2 libmnl
1073 lfsmake2 libnfnetlink
1074 lfsmake2 libnetfilter_queue
1075 lfsmake2 libnetfilter_conntrack
1076 lfsmake2 libnetfilter_cthelper
1077 lfsmake2 libnetfilter_cttimeout
1078 lfsmake2 iptables
1079 lfsmake2 screen
1080 lfsmake2 elfutils
1081
1082 case "${BUILD_ARCH}" in
1083 x86_64)
1084 lfsmake2 linux KCFG=""
1085 # lfsmake2 backports KCFG=""
1086 # lfsmake2 e1000e KCFG=""
1087 # lfsmake2 igb KCFG=""
1088 # lfsmake2 ixgbe KCFG=""
1089 lfsmake2 xtables-addons KCFG=""
1090 lfsmake2 linux-initrd KCFG=""
1091 ;;
1092 i586)
1093 # x86-pae (Native and new XEN) kernel build
1094 lfsmake2 linux KCFG="-pae"
1095 # lfsmake2 backports KCFG="-pae"
1096 # lfsmake2 e1000e KCFG="-pae"
1097 # lfsmake2 igb KCFG="-pae"
1098 # lfsmake2 ixgbe KCFG="-pae"
1099 lfsmake2 xtables-addons KCFG="-pae"
1100 lfsmake2 linux-initrd KCFG="-pae"
1101
1102 # x86 kernel build
1103 lfsmake2 linux KCFG=""
1104 # lfsmake2 backports KCFG=""
1105 # lfsmake2 e1000e KCFG=""
1106 # lfsmake2 igb KCFG=""
1107 # lfsmake2 ixgbe KCFG=""
1108 lfsmake2 xtables-addons KCFG=""
1109 lfsmake2 linux-initrd KCFG=""
1110 ;;
1111
1112 armv5tel)
1113 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
1114 lfsmake2 linux KCFG="-kirkwood"
1115 # lfsmake2 backports KCFG="-kirkwood"
1116 # lfsmake2 e1000e KCFG="-kirkwood"
1117 # lfsmake2 igb KCFG="-kirkwood"
1118 # lfsmake2 ixgbe KCFG="-kirkwood"
1119 lfsmake2 xtables-addons KCFG="-kirkwood"
1120 lfsmake2 linux-initrd KCFG="-kirkwood"
1121
1122 # arm multi platform (Panda, Wandboard ...) kernel build
1123 lfsmake2 linux KCFG="-multi"
1124 # lfsmake2 backports KCFG="-multi"
1125 # lfsmake2 e1000e KCFG="-multi"
1126 # lfsmake2 igb KCFG="-multi"
1127 # lfsmake2 ixgbe KCFG="-multi"
1128 lfsmake2 xtables-addons KCFG="-multi"
1129 lfsmake2 linux-initrd KCFG="-multi"
1130 ;;
1131 esac
1132 lfsmake2 xtables-addons USPACE="1"
1133 lfsmake2 openssl
1134 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1135 lfsmake2 openssl-compat
1136 lfsmake2 libgpg-error
1137 lfsmake2 libgcrypt
1138 lfsmake2 libassuan
1139 lfsmake2 nettle
1140 lfsmake2 libevent
1141 lfsmake2 libevent2
1142 lfsmake2 expat
1143 lfsmake2 apr
1144 lfsmake2 aprutil
1145 lfsmake2 unbound
1146 lfsmake2 gnutls
1147 lfsmake2 bind
1148 lfsmake2 dhcp
1149 lfsmake2 dhcpcd
1150 lfsmake2 boost
1151 lfsmake2 linux-atm
1152 lfsmake2 gdbm
1153 lfsmake2 pam
1154 lfsmake2 curl
1155 lfsmake2 tcl
1156 lfsmake2 sqlite
1157 lfsmake2 libffi
1158 lfsmake2 python
1159 lfsmake2 python3
1160 lfsmake2 ca-certificates
1161 lfsmake2 fireinfo
1162 lfsmake2 libnet
1163 lfsmake2 libnl
1164 lfsmake2 libnl-3
1165 lfsmake2 libidn
1166 lfsmake2 nasm
1167 lfsmake2 libjpeg
1168 lfsmake2 libjpeg-compat
1169 lfsmake2 libexif
1170 lfsmake2 libpng
1171 lfsmake2 libtiff
1172 lfsmake2 libart
1173 lfsmake2 gd
1174 lfsmake2 popt
1175 lfsmake2 slang
1176 lfsmake2 newt
1177 lfsmake2 libsmooth
1178 lfsmake2 attr
1179 lfsmake2 acl
1180 lfsmake2 libcap
1181 lfsmake2 pciutils
1182 lfsmake2 usbutils
1183 lfsmake2 libxml2
1184 lfsmake2 libxslt
1185 lfsmake2 BerkeleyDB
1186 lfsmake2 cyrus-sasl
1187 lfsmake2 openldap
1188 lfsmake2 apache2
1189 lfsmake2 web-user-interface
1190 lfsmake2 flag-icons
1191 lfsmake2 jquery
1192 lfsmake2 bootstrap
1193 lfsmake2 arping
1194 lfsmake2 beep
1195 lfsmake2 dvdrtools
1196 lfsmake2 dosfstools
1197 lfsmake2 reiserfsprogs
1198 lfsmake2 xfsprogs
1199 lfsmake2 sysfsutils
1200 lfsmake2 fuse
1201 lfsmake2 ntfs-3g
1202 lfsmake2 ethtool
1203 lfsmake2 ez-ipupdate
1204 lfsmake2 fcron
1205 lfsmake2 perl-GD
1206 lfsmake2 GD-Graph
1207 lfsmake2 GD-TextUtil
1208 lfsmake2 perl-Device-SerialPort
1209 lfsmake2 perl-Device-Modem
1210 lfsmake2 perl-Apache-Htpasswd
1211 lfsmake2 gnupg
1212 lfsmake2 hdparm
1213 lfsmake2 sdparm
1214 lfsmake2 mtools
1215 lfsmake2 whatmask
1216 lfsmake2 conntrack-tools
1217 lfsmake2 libupnp
1218 lfsmake2 ipaddr
1219 lfsmake2 iputils
1220 lfsmake2 l7-protocols
1221 lfsmake2 hwdata
1222 lfsmake2 logrotate
1223 lfsmake2 logwatch
1224 lfsmake2 misc-progs
1225 lfsmake2 nano
1226 lfsmake2 URI
1227 lfsmake2 HTML-Tagset
1228 lfsmake2 HTML-Parser
1229 lfsmake2 HTML-Template
1230 lfsmake2 Compress-Zlib
1231 lfsmake2 Digest
1232 lfsmake2 Digest-SHA1
1233 lfsmake2 Digest-HMAC
1234 lfsmake2 libwww-perl
1235 lfsmake2 Net-DNS
1236 lfsmake2 Net-IPv4Addr
1237 lfsmake2 Net_SSLeay
1238 lfsmake2 IO-Stringy
1239 lfsmake2 IO-Socket-SSL
1240 lfsmake2 Unix-Syslog
1241 lfsmake2 Mail-Tools
1242 lfsmake2 MIME-Tools
1243 lfsmake2 Net-Server
1244 lfsmake2 Convert-TNEF
1245 lfsmake2 Convert-UUlib
1246 lfsmake2 Archive-Tar
1247 lfsmake2 Archive-Zip
1248 lfsmake2 Text-Tabs+Wrap
1249 lfsmake2 Locale-Country
1250 lfsmake2 XML-Parser
1251 lfsmake2 Crypt-PasswdMD5
1252 lfsmake2 Net-Telnet
1253 lfsmake2 python-setuptools
1254 lfsmake2 python-clientform
1255 lfsmake2 python-mechanize
1256 lfsmake2 python-feedparser
1257 lfsmake2 python-rssdler
1258 lfsmake2 python-inotify
1259 lfsmake2 python-docutils
1260 lfsmake2 python-daemon
1261 lfsmake2 python-ipaddress
1262 lfsmake2 glib
1263 lfsmake2 GeoIP
1264 lfsmake2 ntp
1265 lfsmake2 openssh
1266 lfsmake2 fontconfig
1267 lfsmake2 dejavu-fonts-ttf
1268 lfsmake2 ubuntu-font-family
1269 lfsmake2 freefont
1270 lfsmake2 pixman
1271 lfsmake2 cairo
1272 lfsmake2 pango
1273 lfsmake2 rrdtool
1274 lfsmake2 setserial
1275 lfsmake2 setup
1276 lfsmake2 libdnet
1277 lfsmake2 daq
1278 lfsmake2 snort
1279 lfsmake2 oinkmaster
1280 lfsmake2 squid
1281 lfsmake2 squidguard
1282 lfsmake2 calamaris
1283 lfsmake2 tcpdump
1284 lfsmake2 traceroute
1285 lfsmake2 vlan
1286 lfsmake2 wireless
1287 lfsmake2 pakfire
1288 lfsmake2 spandsp
1289 lfsmake2 lz4
1290 lfsmake2 lzo
1291 lfsmake2 openvpn
1292 lfsmake2 mpage
1293 lfsmake2 dbus
1294 lfsmake2 intltool
1295 lfsmake2 libdaemon
1296 lfsmake2 cups
1297 lfsmake2 lcms2
1298 lfsmake2 ghostscript
1299 lfsmake2 qpdf
1300 lfsmake2 poppler
1301 lfsmake2 cups-filters
1302 lfsmake2 epson-inkjet-printer-escpr
1303 lfsmake2 foomatic
1304 lfsmake2 hplip
1305 lfsmake2 cifs-utils
1306 lfsmake2 krb5
1307 lfsmake2 samba
1308 lfsmake2 sudo
1309 lfsmake2 mc
1310 lfsmake2 wget
1311 lfsmake2 bridge-utils
1312 # lfsmake2 screen
1313 lfsmake2 smartmontools
1314 lfsmake2 htop
1315 lfsmake2 chkconfig
1316 lfsmake2 postfix
1317 lfsmake2 fetchmail
1318 lfsmake2 cyrus-imapd
1319 lfsmake2 clamav
1320 lfsmake2 spamassassin
1321 lfsmake2 amavisd
1322 lfsmake2 dma
1323 lfsmake2 alsa
1324 lfsmake2 mpfire
1325 lfsmake2 guardian
1326 lfsmake2 libid3tag
1327 lfsmake2 libmad
1328 lfsmake2 libogg
1329 lfsmake2 libvorbis
1330 lfsmake2 libdvbpsi
1331 lfsmake2 flac
1332 lfsmake2 lame
1333 lfsmake2 sox
1334 lfsmake2 libshout
1335 lfsmake2 xvid
1336 lfsmake2 libmpeg2
1337 lfsmake2 libarchive
1338 lfsmake2 cmake
1339 lfsmake2 gnump3d
1340 lfsmake2 rsync
1341 lfsmake2 libtirpc
1342 lfsmake2 rpcbind
1343 lfsmake2 nfs
1344 lfsmake2 gnu-netcat
1345 lfsmake2 ncat
1346 lfsmake2 nmap
1347 lfsmake2 etherwake
1348 lfsmake2 bwm-ng
1349 lfsmake2 sysstat
1350 lfsmake2 strongswan
1351 lfsmake2 rng-tools
1352 lfsmake2 lsof
1353 lfsmake2 br2684ctl
1354 lfsmake2 pcmciautils
1355 lfsmake2 lm_sensors
1356 lfsmake2 liboping
1357 lfsmake2 collectd
1358 lfsmake2 elinks
1359 lfsmake2 igmpproxy
1360 lfsmake2 fbset
1361 lfsmake2 opus
1362 lfsmake2 python-six
1363 lfsmake2 python-pyparsing
1364 lfsmake2 spice-protocol
1365 lfsmake2 spice
1366 lfsmake2 sdl
1367 lfsmake2 libusbredir
1368 lfsmake2 qemu
1369 lfsmake2 sane
1370 lfsmake2 netpbm
1371 lfsmake2 netsnmpd
1372 lfsmake2 nagios_nrpe
1373 lfsmake2 nagios-plugins
1374 lfsmake2 icinga
1375 lfsmake2 ebtables
1376 lfsmake2 directfb
1377 lfsmake2 faad2
1378 lfsmake2 ffmpeg
1379 lfsmake2 vdr
1380 lfsmake2 vdr_streamdev
1381 lfsmake2 vdr_epgsearch
1382 lfsmake2 vdr_dvbapi
1383 lfsmake2 vdr_eepg
1384 lfsmake2 w_scan
1385 lfsmake2 icecast
1386 lfsmake2 icegenerator
1387 lfsmake2 mpd
1388 lfsmake2 libmpdclient
1389 lfsmake2 mpc
1390 lfsmake2 perl-Net-SMTP-SSL
1391 lfsmake2 perl-MIME-Base64
1392 lfsmake2 perl-Authen-SASL
1393 lfsmake2 perl-MIME-Lite
1394 lfsmake2 perl-Email-Date-Format
1395 lfsmake2 git
1396 lfsmake2 squidclamav
1397 lfsmake2 vnstat
1398 lfsmake2 iw
1399 lfsmake2 wpa_supplicant
1400 lfsmake2 hostapd
1401 lfsmake2 pycurl
1402 lfsmake2 urlgrabber
1403 lfsmake2 syslinux
1404 lfsmake2 tftpd
1405 lfsmake2 cpufrequtils
1406 lfsmake2 bluetooth
1407 lfsmake2 gutenprint
1408 lfsmake2 apcupsd
1409 lfsmake2 iperf
1410 lfsmake2 iperf3
1411 lfsmake2 7zip
1412 lfsmake2 lynis
1413 lfsmake2 streamripper
1414 lfsmake2 sshfs
1415 lfsmake2 taglib
1416 lfsmake2 sslh
1417 lfsmake2 perl-gettext
1418 lfsmake2 perl-Sort-Naturally
1419 lfsmake2 vdradmin
1420 lfsmake2 miau
1421 lfsmake2 perl-DBI
1422 lfsmake2 perl-DBD-SQLite
1423 lfsmake2 perl-File-ReadBackwards
1424 lfsmake2 openvmtools
1425 lfsmake2 motion
1426 lfsmake2 joe
1427 lfsmake2 monit
1428 lfsmake2 nut
1429 lfsmake2 watchdog
1430 lfsmake2 libpri
1431 lfsmake2 libsrtp
1432 lfsmake2 jansson
1433 lfsmake2 asterisk
1434 lfsmake2 usb_modeswitch
1435 lfsmake2 usb_modeswitch_data
1436 lfsmake2 zerofree
1437 lfsmake2 minicom
1438 lfsmake2 ddrescue
1439 lfsmake2 miniupnpd
1440 lfsmake2 client175
1441 lfsmake2 powertop
1442 lfsmake2 parted
1443 lfsmake2 swig
1444 lfsmake2 u-boot
1445 lfsmake2 u-boot-kirkwood
1446 lfsmake2 python-typing
1447 lfsmake2 python-m2crypto
1448 lfsmake2 wireless-regdb
1449 lfsmake2 crda
1450 lfsmake2 libsolv
1451 lfsmake2 python-distutils-extra
1452 lfsmake2 python-lzma
1453 lfsmake2 python-progressbar
1454 lfsmake2 python-xattr
1455 lfsmake2 ddns
1456 lfsmake2 transmission
1457 lfsmake2 dpfhack
1458 lfsmake2 lcd4linux
1459 lfsmake2 mtr
1460 lfsmake2 minidlna
1461 lfsmake2 acpid
1462 lfsmake2 fping
1463 lfsmake2 telnet
1464 lfsmake2 xinetd
1465 lfsmake2 gpgme
1466 lfsmake2 pygpgme
1467 lfsmake2 pakfire3
1468 lfsmake2 stress
1469 lfsmake2 libstatgrab
1470 lfsmake2 sarg
1471 lfsmake2 check_mk_agent
1472 lfsmake2 nginx
1473 lfsmake2 sendEmail
1474 lfsmake2 sysbench
1475 lfsmake2 strace
1476 lfsmake2 ltrace
1477 lfsmake2 ipfire-netboot
1478 lfsmake2 lcdproc
1479 lfsmake2 bitstream
1480 lfsmake2 multicat
1481 lfsmake2 keepalived
1482 lfsmake2 ipvsadm
1483 lfsmake2 perl-Carp-Clan
1484 lfsmake2 perl-Date-Calc
1485 lfsmake2 perl-Date-Manip
1486 lfsmake2 perl-File-Tail
1487 lfsmake2 perl-TimeDate
1488 lfsmake2 swatch
1489 lfsmake2 tor
1490 lfsmake2 arm
1491 lfsmake2 wavemon
1492 lfsmake2 iptraf-ng
1493 lfsmake2 iotop
1494 lfsmake2 stunnel
1495 lfsmake2 bacula
1496 lfsmake2 batctl
1497 lfsmake2 perl-Font-TTF
1498 lfsmake2 perl-IO-String
1499 lfsmake2 perl-PDF-API2
1500 lfsmake2 squid-accounting
1501 lfsmake2 pigz
1502 lfsmake2 tmux
1503 lfsmake2 perl-Text-CSV_XS
1504 lfsmake2 haproxy
1505 lfsmake2 ipset
1506 lfsmake2 lua
1507 lfsmake2 dnsdist
1508 lfsmake2 bird
1509 lfsmake2 dmidecode
1510 lfsmake2 mcelog
1511 lfsmake2 rtpproxy
1512 lfsmake2 util-macros
1513 lfsmake2 libpciaccess
1514 lfsmake2 libyajl
1515 lfsmake2 libvirt
1516 lfsmake2 freeradius
1517 lfsmake2 perl-common-sense
1518 lfsmake2 perl-inotify2
1519 lfsmake2 perl-Net-IP
1520 lfsmake2 wio
1521 lfsmake2 iftop
1522 lfsmake2 mdns-repeater
1523 lfsmake2 i2c-tools
1524 }
1525
1526 buildinstaller() {
1527 # Run installer scripts one by one
1528 LOGFILE="$BASEDIR/log/_build.installer.log"
1529 export LOGFILE
1530 lfsmake2 memtest
1531 lfsmake2 installer
1532 # use toolchain bash for chroot to strip
1533 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
1534 }
1535
1536 buildpackages() {
1537 LOGFILE="$BASEDIR/log/_build.packages.log"
1538 export LOGFILE
1539 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1540
1541
1542 # Generating list of packages used
1543 print_line "Generating packages list from logs"
1544 rm -f $BASEDIR/doc/packages-list
1545 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1546 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1547 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1548 fi
1549 done
1550 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1551 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1552 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1553 rm -f $BASEDIR/doc/packages-list
1554 # packages-list.txt is ready to be displayed for wiki page
1555 print_status DONE
1556
1557 # Update changelog
1558 cd $BASEDIR
1559 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1560 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1561 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1562
1563 # Create images for install
1564 lfsmake2 cdrom
1565
1566 # Check if there is a loop device for building in virtual environments
1567 modprobe loop 2>/dev/null
1568 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1569 lfsmake2 flash-images
1570 fi
1571
1572 mv $LFS/install/images/{*.iso,*.tgz,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1573
1574 ipfirepackages
1575
1576 lfsmake2 xen-image
1577 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1578
1579 cd $BASEDIR
1580
1581 # remove not useable iso on armv5tel (needed to build flash images)
1582 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1583
1584 for i in `ls *.bz2 *.img.gz *.iso`; do
1585 md5sum $i > $i.md5
1586 done
1587 cd $PWD
1588
1589 # Cleanup
1590 stdumount
1591 rm -rf $BASEDIR/build/tmp/*
1592
1593 cd $PWD
1594 }
1595
1596 ipfirepackages() {
1597 lfsmake2 core-updates
1598
1599 local i
1600 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1601 i=$(basename ${i})
1602 if [ -e $BASEDIR/lfs/$i ]; then
1603 ipfiredist $i
1604 else
1605 echo -n $i
1606 print_status SKIP
1607 fi
1608 done
1609 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1610 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1611 rm -rf $BASEDIR/build/install/packages/*
1612 }
1613
1614 while [ $# -gt 0 ]; do
1615 case "${1}" in
1616 --target=*)
1617 configure_build "${1#--target=}"
1618 ;;
1619 -*)
1620 exiterror "Unknown configuration option: ${1}"
1621 ;;
1622 *)
1623 # Found a command, so exit options parsing.
1624 break
1625 ;;
1626 esac
1627 shift
1628 done
1629
1630 # See what we're supposed to do
1631 case "$1" in
1632 build)
1633 START_TIME=$(now)
1634
1635 # Clear screen
1636 ${INTERACTIVE} && clear
1637
1638 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1639 #only restore on a clean disk
1640 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1641 if [ ! -n "$PACKAGE" ]; then
1642 print_build_stage "Full toolchain compilation"
1643 prepareenv
1644 buildtoolchain
1645 else
1646 PACKAGENAME=${PACKAGE%.tar.xz}
1647 print_build_stage "Packaged toolchain compilation"
1648 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1649 tar axf $PACKAGE
1650 prepareenv
1651 else
1652 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1653 fi
1654 fi
1655 else
1656 prepareenv
1657 fi
1658
1659 print_build_stage "Building LFS"
1660 buildbase
1661
1662 print_build_stage "Building IPFire"
1663 buildipfire
1664
1665 print_build_stage "Building installer"
1666 buildinstaller
1667
1668 print_build_stage "Building packages"
1669 buildpackages
1670
1671 print_build_stage "Checking Logfiles for new Files"
1672
1673 cd $BASEDIR
1674 tools/checknewlog.pl
1675 tools/checkrootfiles
1676 cd $PWD
1677
1678 print_build_summary $(( $(now) - ${START_TIME} ))
1679 ;;
1680 shell)
1681 # enter a shell inside LFS chroot
1682 # may be used to changed kernel settings
1683 prepareenv
1684 entershell
1685 ;;
1686 clean)
1687 print_line "Cleaning build directory..."
1688
1689 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1690 $LOSETUP -d $i 2>/dev/null
1691 done
1692 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1693 umount $i
1694 done
1695 stdumount
1696 for i in `seq 0 7`; do
1697 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1698 umount /dev/loop${i} 2>/dev/null;
1699 losetup -d /dev/loop${i} 2>/dev/null;
1700 fi;
1701 done
1702 rm -rf $BASEDIR/build
1703 rm -rf $BASEDIR/cdrom
1704 rm -rf $BASEDIR/packages
1705 rm -rf $BASEDIR/log
1706 if [ -h "${TOOLS_DIR}" ]; then
1707 rm -f "${TOOLS_DIR}"
1708 fi
1709 rm -f $BASEDIR/ipfire-*
1710 print_status DONE
1711 ;;
1712 downloadsrc)
1713 if [ ! -d $BASEDIR/cache ]; then
1714 mkdir $BASEDIR/cache
1715 fi
1716 mkdir -p $BASEDIR/log
1717 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1718 FINISHED=0
1719 cd $BASEDIR/lfs
1720 for c in `seq $MAX_RETRIES`; do
1721 if (( FINISHED==1 )); then
1722 break
1723 fi
1724 FINISHED=1
1725 cd $BASEDIR/lfs
1726 for i in *; do
1727 if [ -f "$i" -a "$i" != "Config" ]; then
1728 lfsmakecommoncheck ${i} || continue
1729
1730 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1731 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1732 if [ $? -ne 0 ]; then
1733 print_status FAIL
1734 FINISHED=0
1735 else
1736 if [ $c -eq 1 ]; then
1737 print_status DONE
1738 fi
1739 fi
1740 fi
1741 done
1742 done
1743 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1744 ERROR=0
1745 for i in *; do
1746 if [ -f "$i" -a "$i" != "Config" ]; then
1747 lfsmakecommoncheck ${i} > /dev/null || continue
1748 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1749 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1750 if [ $? -ne 0 ]; then
1751 echo -ne "MD5 difference in lfs/$i"
1752 print_status FAIL
1753 ERROR=1
1754 fi
1755 fi
1756 done
1757 if [ $ERROR -eq 0 ]; then
1758 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1759 print_status DONE
1760 else
1761 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1762 print_status FAIL
1763 fi
1764 cd - >/dev/null 2>&1
1765 ;;
1766 toolchain)
1767 # Clear screen
1768 ${INTERACTIVE} && clear
1769
1770 prepareenv
1771 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1772 buildtoolchain
1773 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1774 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1775 cd $BASEDIR && XZ_OPT="$(XZ_OPT)" tar -Jc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz --xz \
1776 build/${TOOLS_DIR} build/bin/sh log >> $LOGFILE
1777 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1778 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1779 stdumount
1780 ;;
1781 gettoolchain)
1782 # arbitrary name to be updated in case of new toolchain package upload
1783 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1784 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1785 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1786 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1787 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1788 cd $BASEDIR/cache/toolchains
1789 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1790 if [ $? -ne 0 ]; then
1791 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1792 else
1793 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1794 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1795 else
1796 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1797 fi
1798 fi
1799 else
1800 echo "Toolchain is already downloaded. Exiting..."
1801 fi
1802 ;;
1803 uploadsrc)
1804 PWD=`pwd`
1805 if [ -z $IPFIRE_USER ]; then
1806 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1807 print_status FAIL
1808 exit 1
1809 fi
1810
1811 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1812 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1813
1814 for file in ${BASEDIR}/cache/*; do
1815 [ -d "${file}" ] && continue
1816 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1817 NEW_FILES="$NEW_FILES $file"
1818 done
1819 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1820 cd $BASEDIR
1821 cd $PWD
1822 exit 0
1823 ;;
1824 lang)
1825 echo -ne "Checking the translations for missing or obsolete strings..."
1826 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1827 $BASEDIR/tools/sort_strings.pl en
1828 $BASEDIR/tools/sort_strings.pl de
1829 $BASEDIR/tools/sort_strings.pl fr
1830 $BASEDIR/tools/sort_strings.pl es
1831 $BASEDIR/tools/sort_strings.pl pl
1832 $BASEDIR/tools/sort_strings.pl ru
1833 $BASEDIR/tools/sort_strings.pl nl
1834 $BASEDIR/tools/sort_strings.pl tr
1835 $BASEDIR/tools/sort_strings.pl it
1836 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1837 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1838 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1839 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1840 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1841 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1842 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1843 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1844 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1845 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1846 print_status DONE
1847
1848 echo -ne "Updating language lists..."
1849 update_language_list ${BASEDIR}/src/installer/po
1850 update_language_list ${BASEDIR}/src/setup/po
1851 print_status DONE
1852 ;;
1853 *)
1854 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1855 cat doc/make.sh-usage
1856 ;;
1857 esac